package data;

import java.util.*;
import javax.ejb.*;
import java.util.Properties;
import javax.mail.*;
import javax.naming.*;
import javax.mail.internet.*;

public class EmailCustomer  {

    private Set apps = new HashSet();
    private Session session;

    public EmailCustomer (Session session)  {
        this.session = session;
    }

    public void addApplicant (String name) {
        apps.add(name);
    }

    public void newMessage () {
        apps.clear();
    }

    public void sendMail (String recipient)  throws MessagingException {
        System.out.println("emailCustomer: "+recipient+" - "+apps);
        MimeMessage message = new MimeMessage(session);

        if (apps.size() == 0)
            message.setText("Sorry, there are no applicants that match your job requirements.\r\n");
        else {
            StringBuffer msg = new StringBuffer();
            msg.append("The following is a list of the applicants for you to consider.\r\n");
            Iterator appsIter = apps.iterator();
            while (appsIter.hasNext()) {
                String applicant = (String)appsIter.next();
                msg.append (applicant + "\r\n");
            }
            message.setText(msg.toString());
        }

        message.setSubject("Email from the Agency Case Study");
        message.setFrom(new InternetAddress("agency@localhost"));
        message.addRecipient(Message.RecipientType.TO,new InternetAddress(recipient));

        Transport.send(message);
    }
}