import java.util.Properties;
import javax.mail.*;
import javax.mail.internet.*;
import java.io.*;

public class DeleteMail {
    public static void main(String[] args) {
        if (args.length!=3) {
        System.out.println("Usage: DeleteMail POPHost username password");
            System.exit(1);
        }

        String host = args[0];
        String username = args[1];
        String password = args[2];

        try {
            Properties props = new Properties();
            Session session = Session.getDefaultInstance(props, null);
            Store store = session.getStore("pop3");
            store.connect(host, username, password);

            Folder folder = store.getFolder("INBOX");
            folder.open(Folder.READ_WRITE);
            Message messages[] = folder.getMessages();

            for (int i=0; i<messages.length; i++) {
                Message msg = messages[i];
                System.out.println(i + ": " + msg.getFrom()[0] + "\t" +
                     msg.getSubject() + "\t" +
                     msg.getSentDate() + "\n\n");
                msg.writeTo(System.out);
                msg.setFlag(Flags.Flag.DELETED, true);
            }

            folder.close(true);
            store.close();
        }
        catch (MessagingException me) {
            System.err.println(me);
        }
        catch (IOException ioe) {
            System.err.println(ioe);
        }
    }
}
