package webagency;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import agency.*;
import javax.naming.*;
import java.rmi.*;
import javax.rmi.*;
import javax.ejb.*;
import java.util.*;

public class CustomerServlet extends HttpServlet
{
  private Agency agency;

  public void init(){
     try {
      InitialContext ic = new InitialContext();
      Object lookup = ic.lookup("java:comp/env/ejb/Agency");
      AgencyHome home = (AgencyHome)PortableRemoteObject.narrow(lookup, AgencyHome.class);
      agency = home.create();
    }
    catch (NamingException ex) {
      System.err.println(ex);
    }
    catch (ClassCastException ex) {
      System.err.println(ex);
    }
    catch (CreateException ex) {
      System.err.println(ex);
    }
    catch (RemoteException ex) {
      System.err.println(ex);
    }
  }

  private String findLogin (String customer) {
      try {
        List customers;     // list of String[], first row = column names
        synchronized(agency) {
            customers = agency.select("Customer");
        }
        for (int i = 1;  i < customers.size(); i++) {
          String[] row = (String[])customers.get(i);
          if (row[1].equals(customer))
             return (String)row[0];
        }
    }
    catch (RemoteException ex) {
      System.err.println(ex);
    }
      return null;
  }

  private void outputJobs (PrintWriter out, String customer) {
    try {
      List jobs;   // list of String[], first row = column names
        synchronized(agency) {
          jobs = agency.select("Job");
        }


      String login = findLogin (customer);
      if (login != null) {
        out.println ("<P><FONT SIZE='+1'>Listing of jobs for " + customer + "</FONT></P>");
        out.println ("<TABLE BORDER='1' BORDERCOLOR='SILVER' BGCOLOR='IVORY' CELLPADDING='5'><TR>");

        String[] headerRow = (String[])jobs.get(0);
        for (int i = 0; i < headerRow.length; i++) {
          out.println ("<TH ALIGN='LEFT'>" + headerRow[i] + "</TH>");
        }
        out.println ("</TR>");
        for (int i = 1; i < jobs.size(); i++) {
          String[] row = (String[])jobs.get(i);
          if (row[1].equals(login)) {
             out.println ("<TR>");
             for (int r = 0; r < row.length; r++) {
               out.println ("<TD>" + row[r] + "</TD>");
             }
             out.println ("</TR>");
          }
        }
      }
      out.println ("</TABLE>");
    }
    catch (RemoteException ex) {
      System.err.println(ex);
    }
  }
  private void outputForm (PrintWriter out) {
    try {
        out.println ("<P>Select a Customer from the list to display their jobs</P>");
        out.println ("<FORM>");
        out.println ("<SELECT NAME='customer' SIZE='1'>");
        List customers;     // list of String[], first row = column names
        synchronized(agency) {
            customers = agency.select("Customer");
        }
        for (int i = 1;  i < customers.size(); i++) {
          String[] row = (String[])customers.get(i);
          out.print ("<OPTION>");
          out.print (row[1]);
        }
        out.println ("</SELECT>");
        out.println ("<INPUT TYPE=submit>");
        out.println ("</FORM>");
    }
    catch (RemoteException ex) {
      System.err.println(ex);
    }
  }

  public void doGet(HttpServletRequest req, HttpServletResponse res)
         throws ServletException, IOException {
    try {
      String customer = null;
      String agencyName;
        synchronized(agency) {
                agencyName = agency.getAgencyName();
            }
      res.setContentType ("text/html");
      PrintWriter out = res.getWriter();

      // print out form
      out.println ("<HTML>");
      out.println ("<HEAD><TITLE>" + agencyName + " List Customers</TITLE></HEAD>");
      out.println ("<BODY><FONT FACE=ARIAL COLOR=DARKBLUE");
      out.println ("<H1><FONT SIZE='+3'>" + agencyName + " List Customers and Jobs</FONT></H1>");

      customer = req.getParameter("customer");
      if (customer != null) {
        outputJobs(out, customer);
      }
      outputForm (out);

      // format & display
      out.println ("</FONT></BODY>");
      out.println ("</HTML>");
    }
    catch (RemoteException ex) {
      System.err.println(ex);
    }
  }
}
