package webagency;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import agency.*;
import javax.naming.*;
import java.rmi.*;
import javax.rmi.*;
import javax.ejb.*;
import java.util.*;

public class DeleteCustomerServlet extends HttpServlet
{
  private Agency agency;

  public void init(){
     try {
      InitialContext ic = new InitialContext();
      Object lookup = ic.lookup("java:comp/env/ejb/Agency");
      AgencyHome home = (AgencyHome)PortableRemoteObject.narrow(lookup, AgencyHome.class);
      agency = home.create();
    }
    catch (NamingException ex) {
      System.err.println(ex);
    }
    catch (ClassCastException ex) {
      System.err.println(ex);
    }
    catch (CreateException ex) {
      System.err.println(ex);
    }
    catch (RemoteException ex) {
      System.err.println(ex);
    }
  }

  private boolean deleteCustomer (PrintWriter out, String login) {
    if (login==null || login.length()==0) {
      out.println ("No login name specified - please try again");
      return false;
    }     
    try {
      synchronized(agency) {
          agency.deleteCustomer(login);
      }
      out.println ("Customer "+login+" deleted successfully");
      return true;
    }
    catch (NotFoundException ex) {
      out.println("Login name \""+login+"\" not found - choose another");
      return false;
    }
    catch (RemoteException ex) {
      out.println("Internal remote error: "+ex);
      return false;
    }
  }

  private void showForm (PrintWriter out) {
    out.println ("<P>Enter login name to delete a customer</P>");
    out.println ("<FORM><TABLE>");
    out.println ("<TR><TD>Login:</TD><TD><INPUT type='text' name='login'</TD></TR>");
    out.println ("<TR><TD colspan='2'><INPUT type='submit' value='Delete Customer'></TD></TR>");
    out.println ("</TABLE></FORM>");
  }

  public void doGet(HttpServletRequest req, HttpServletResponse res)
         throws ServletException, IOException {
    try {
      String agencyName;
      String customer = null;

      synchronized(agency) {
          agencyName = agency.getAgencyName();
        }

      res.setContentType ("text/html");
      PrintWriter out = res.getWriter();

      // print out page
      out.println ("<HTML>");
      out.println ("<HEAD><TITLE>" + agencyName + " Delete Customer</TITLE></HEAD>");
      out.println ("<BODY><FONT FACE=ARIAL COLOR=DARKBLUE");
      out.println ("<H1><FONT SIZE=+3>" + agencyName + " Delete Customer</FONT></H1>");

      // check if new customer specified
      String login = req.getParameter("login");
      if (login != null) {
        if (!deleteCustomer(out,login))
          showForm(out);
      }
      else
        showForm (out);

      // format & display
      out.println ("</FONT></BODY>");
      out.println ("</HTML>");
    }
    catch (RemoteException ex) {
      System.err.println(ex);
    }
  }
}
