import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class AuditFilter extends HttpServlet implements Filter {
    private FilterConfig filterConfig = null;

    public void init(FilterConfig filterConfig)
       throws ServletException {
       this.filterConfig = filterConfig;
    }

    public void destroy() {
       this.filterConfig = null;
    }

    public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain)
                                       throws IOException, ServletException {
        if (filterConfig == null)
            return;
        StringBuffer buf = new StringBuffer();
        buf.append ("The number of hits is: ");
        synchronized (this) {
            Integer counter = (Integer)filterConfig.getServletContext().getAttribute("Counter");
            if (counter == null)
                counter = new Integer(1);
            else
                counter = new Integer(counter.intValue() + 1);
            buf.append (counter.toString());
            filterConfig.getServletContext().setAttribute("Counter", counter);
        }
        chain.doFilter(req, res);
    }
}

